package com.bizmatics.mhfire.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.common.core.util.BeanMapperUtils;
import com.bizmatics.common.mvc.base.AbstractCrudService;
import com.bizmatics.mhfire.model.Device;
import com.bizmatics.mhfire.persistence.mapper.DeviceMapper;
import com.bizmatics.mhfire.persistence.mapper.vo.DeviceCollectVO;
import com.bizmatics.mhfire.service.DeviceService;
import com.bizmatics.mhfire.service.vo.DeviceMapVO;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 设备信息表 服务实现类
 * </p>
 *
 * @author ya
 * @since 2021-11-25
 */
@Service
public class DeviceServiceImpl extends AbstractCrudService<DeviceMapper, Device> implements DeviceService {

    @Override
    public List<DeviceMapVO> getMapList(Date startTime, Date endTime) {
        LambdaQueryWrapper<Device> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.select(Device::getId,Device::getLatitude,Device::getLongitude)
                .between(null != startTime && endTime != null,Device::getCreateTime,startTime,endTime)
                .orderByDesc(Device::getCreateTime);
        List<Device> list = this.list(queryWrapper);
        return BeanMapperUtils.mapList(list,Device.class,DeviceMapVO.class);
    }

    @Override
    public CommonPage<DeviceCollectVO> getCollect(Integer current, Integer size, String deviceType, String deviceCode,Date startTime, Date endTime) {
        Page<DeviceCollectVO> page = new Page<>(current, size);
        page = baseMapper.selectCollect(page,deviceType,deviceCode,startTime,endTime);
        return new CommonPage<>(page.getRecords(),page.getTotal(),page.getSize(),page.getCurrent());
    }

    @Override
    public DeviceCollectVO getCollectOne(String deviceType, String deviceCode, Date startTime, Date endTime) {
        return baseMapper.selectCollectOne(deviceType,deviceCode,startTime,endTime);
    }
}
